tests: Use DYLD_LIBRARY_PATH on macOSX
[babeltrace.git] / tests / utils / utils.sh
index 65949bd0467828eda3eb262a1b0b925bbf5b07c0..17137c98b23ab274e33a926ce7450afd85b4874e 100644 (file)
@@ -24,6 +24,29 @@ set -u
 
 scriptdir="$(dirname "${BASH_SOURCE[0]}")"
 
+# The OS on which we are running. See [1] for possible values of 'uname -s'.
+# We do a bit of translation to ease our life down the road for comparison.
+# Export it so that called executables can use it.
+# [1] https://en.wikipedia.org/wiki/Uname#Examples
+if [ "x${BT_OS_TYPE:-}" = "x" ]; then
+       BT_OS_TYPE="$(uname -s)"
+       case "$BT_OS_TYPE" in
+       MINGW*)
+               BT_OS_TYPE="mingw"
+               ;;
+       Darwin)
+               BT_OS_TYPE="darwin"
+               ;;
+       Linux)
+               BT_OS_TYPE="linux"
+               ;;
+       *)
+               BT_OS_TYPE="unsupported"
+               ;;
+       esac
+fi
+export BT_OS_TYPE
+
 # Allow overriding the source and build directories
 if [ "x${BT_TESTS_SRCDIR:-}" = "x" ]; then
        BT_TESTS_SRCDIR="$scriptdir/.."
@@ -45,7 +68,7 @@ fi
 # Allow overriding the babeltrace2 executables
 if [ "x${BT_TESTS_BT2_BIN:-}" = "x" ]; then
        BT_TESTS_BT2_BIN="$BT_TESTS_BUILDDIR/../src/cli/babeltrace2"
-       if [ "x${MSYSTEM:-}" != "x" ]; then
+       if [ "$BT_OS_TYPE" = "mingw" ]; then
                BT_TESTS_BT2_BIN="${BT_TESTS_BT2_BIN}.exe"
        fi
 fi
@@ -53,7 +76,7 @@ export BT_TESTS_BT2_BIN
 
 if [ "x${BT_TESTS_BT2LOG_BIN:-}" = "x" ]; then
        BT_TESTS_BT2LOG_BIN="$BT_TESTS_BUILDDIR/../src/cli/babeltrace2-log"
-       if [ "x${MSYSTEM:-}" != "x" ]; then
+       if [ "$BT_OS_TYPE" = "mingw" ]; then
                BT_TESTS_BT2LOG_BIN="${BT_TESTS_BT2LOG_BIN}.exe"
        fi
 fi
@@ -103,17 +126,17 @@ BT_DEBUG_INFO_PATH="${BT_TESTS_DATADIR}/debug-info"
 
 ### Diff Functions ###
 
-# Checks the difference between:
-#
-# 1. What the CLI outputs when given the arguments "$1" (passed to
-#    `xargs`, so they can include quoted arguments).
-# 2. The file with path "$2".
+# Checks the difference between the content of the file with path "$1"
+# and the output of the CLI when called with the rest of arguments
+# to this function.
 #
 # Returns 0 if there's no difference, and 1 if there is, also printing
 # said difference to the standard error.
 bt_diff_cli() {
-       local args="$1"
-       local expected_file="$2"
+       local expected_file="$1"
+       shift 1
+       local args=("$@")
+
        local temp_output_file
        local temp_diff
        local ret=0
@@ -124,11 +147,11 @@ bt_diff_cli() {
        # Run the CLI to get a detailed file. Strip any \r present due to
        # Windows (\n -> \r\n). "diff --string-trailing-cr" is not used since it
        # is not present on Solaris.
-       echo "$args" | xargs "$BT_TESTS_BT2_BIN" | tr -d "\r" > "$temp_output_file"
+       "$BT_TESTS_BT2_BIN" "${args[@]}" | tr -d "\r" > "$temp_output_file"
 
        # Compare output with expected output
        if ! diff -u "$temp_output_file" "$expected_file" 2>/dev/null >"$temp_diff"; then
-               echo "ERROR: for '$args': actual and expected outputs differ:" >&2
+               echo "ERROR: for '${args[*]}': actual and expected outputs differ:" >&2
                cat "$temp_diff" >&2
                ret=1
        fi
@@ -138,25 +161,21 @@ bt_diff_cli() {
        return $ret
 }
 
-# Checks the difference between:
-#
-# 1. What the CLI outputs when given the arguments:
-#
-#        "$1" -c sink.text.details $3
-#
-# 2. The file with path "$2".
-#
-# Parameter 3 is optional.
+# Checks the difference between the content of the file with path "$1"
+# and the output of the CLI when called on the directory path "$2" with
+# the arguments '-c sink.text.details' and the rest of the arguments to
+# this function.
 #
 # Returns 0 if there's no difference, and 1 if there is, also printing
 # said difference to the standard error.
 bt_diff_details_ctf_single() {
-       local trace_dir="$1"
-       local expected_file="$2"
-       local extra_details_args="${3:-}"
+       local expected_file="$1"
+       local trace_dir="$2"
+       shift 2
+       local extra_details_args=("$@")
 
        # Compare using the CLI with `sink.text.details`
-       bt_diff_cli "\"$trace_dir\" -c sink.text.details $extra_details_args" "$expected_file"
+       bt_diff_cli "$expected_file" "$trace_dir" "-c" "sink.text.details" "${extra_details_args[@]}"
 }
 
 # Calls bt_diff_details_ctf_single(), except that "$1" is the path to a
@@ -166,7 +185,8 @@ bt_diff_details_ctf_single() {
 bt_diff_details_ctf_gen_single() {
        local ctf_gen_prog_path="$1"
        local expected_file="$2"
-       local extra_details_args="${3:-}"
+       shift 2
+       local extra_details_args=("$@")
 
        local temp_trace_dir
        local ret
@@ -181,7 +201,7 @@ bt_diff_details_ctf_gen_single() {
        fi
 
        # Compare using the CLI with `sink.text.details`
-       bt_diff_details_ctf_single "$temp_trace_dir" "$expected_file" "$extra_details_args"
+       bt_diff_details_ctf_single "$expected_file" "$temp_trace_dir" "${extra_details_args[@]}"
        ret=$?
        rm -rf "$temp_trace_dir"
        return $ret
@@ -204,9 +224,12 @@ run_python_bt2() {
        local main_lib_path="${BT_TESTS_BUILDDIR}/../src/lib/.libs"
 
        # Set the library search path so the python interpreter can load libbabeltrace2
-       if [ "x${MSYSTEM:-}" != "x" ]; then
+       if [ "$BT_OS_TYPE" = "mingw" ]; then
                lib_search_var="PATH"
                lib_search_path="${python_provider_path}:${main_lib_path}:${PATH:-}"
+       elif [ "$BT_OS_TYPE" = "darwin" ]; then
+               lib_search_var="DYLD_LIBRARY_PATH"
+               lib_search_path="${python_provider_path}:${main_lib_path}:${DYLD_LIBRARY_PATH:-}"
        else
                lib_search_var="LD_LIBRARY_PATH"
                lib_search_path="${python_provider_path}:${main_lib_path}:${LD_LIBRARY_PATH:-}"
This page took 0.025066 seconds and 4 git commands to generate.